function [signal] = resyn_from_fft(phase, mag, sigLen, fftlen, fs)

%fs = 16000;

if nargin<4
    fftlength = fs*20/1000;
else    
    fftlength = fftlen;
end
if nargin<5
    fs = 16000;
end

stepsize = fs * 0.02/2;
% mag = 10 .^ (mag_dB / 20) - 1;

% j = sqrt(-1);
sig_complex = mag .* exp(phase*1i);

fullFFT = [sig_complex; flipud(conj(sig_complex(2 : fftlength/2, :)))];

signal = zeros(1, sigLen+5000);

% overlap-and-add
for i = 1 : size(fullFFT, 2)
    try
    curFrm = fullFFT(:, i);
    tS = ifft(curFrm, fftlength);
%     tS = ifft(curFrm, 512);
    
    start = (i - 1) * stepsize + 1;
%     start = (i - 1) * 256 + 1;
    finish = start + fftlength - 1;
    
%
    signal(start : finish) = signal(start : finish) + tS';
    catch
        tt=1;
    end
end
signal = real(signal(1 : sigLen))';

end

